;_.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._
;_.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._
;Smoke Engine Example
;Programmed By Matt
;http://www.1matthew.com
;
;Feel free to use this for whatever you want. I like to see examples of my program. Contact me from my 
;website if you use this. Thanks!
;_.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._
;_.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._


Structure Smoke
  X.f
  Y.f
  size.l
  trans.l
  rotate.l
  counter.l
  Xdir.l
  Ydir.l
EndStructure

Structure Missle
  Xpos.l
  Ypos.l
  Xspeed.l
  Yspeed.l
  Sprite.l
  Smoke.l
EndStructure

Global Smokecounter.l
NewList Missle.Missle()

Procedure CreateSmoke(SpriteNumber.l)
  For X = 0 To 200 ; Sprite3D Numbers 0 to 200 are all smokes
    CreateSprite3D(X,SpriteNumber)
  Next X
  Dim smoke.smoke(201)
EndProcedure

Procedure AddSmoke(Xpos.l,Ypos.l,Xdir.l,Ydir.l)
  Smokecounter + 1
  Smoke(SmokeCounter)\X = Xpos
  Smoke(SmokeCounter)\Y = Ypos
  Smoke(SmokeCounter)\Trans = 150
  Smoke(SmokeCounter)\Size = 10
  Smoke(SmokeCounter)\Xdir = Xdir
  Smoke(SmokeCounter)\Ydir = Ydir
  If SmokeCounter > 200
    SmokeCounter = 0
  EndIf
EndProcedure

Procedure AddMissle(Xpos,Ypos,Xspeed,Yspeed,Sprite,Smoke)
  AddElement(Missle())
  Missle()\Xpos = Xpos
  Missle()\Ypos = Ypos
  Missle()\Xspeed = Xspeed
  Missle()\Yspeed = Xspeed
  Missle()\Sprite = Sprite
  Missle()\Smoke = Smoke 
EndProcedure

Procedure AddSmokeArea(X.l,Y.l,Width.l,Height.l,Density.l,XM,YM)
  For X = 0 To Density
    AddSmoke(X+Random(Width),Y+Random(Height),XM,YM)
  Next X
EndProcedure

Procedure SmokeExplosion(X,Y)
  AddSmoke(X,Y,(Random(2)+1),(Random(2)+1))
  AddSmoke(X,Y,-(Random(2)+1),(Random(2)+1))
  AddSmoke(X,Y,(Random(2)+1),-(Random(2)+1))
  AddSmoke(X,Y,(Random(2)+1),-(Random(2)+1))
  AddSmoke(X,Y,0,(Random(2)+1))
  AddSmoke(X,Y,-(Random(2)+1),0)
  AddSmoke(X,Y,0,-(Random(2)+1))
  AddSmoke(X,Y,(Random(2)+1),0)
EndProcedure

Procedure UpdateSmoke()
  For X = 0 To 200
    If Smoke(X)\X <> 0
        Smoke(X)\Size + 2
        Smoke(X)\Trans - 5
        Smoke(X)\Y - 1 + Smoke(X)\Ydir
        Smoke(X)\X - 1 + Smoke(X)\Xdir
        If Smoke(X)\Trans < 2
          Smoke(X)\Trans = 0
        EndIf
        Smoke(X)\Rotate + 2 + Random(2)
        
        ZoomSprite3D(X,Smoke(X)\Size,Smoke(X)\Size)
        RotateSprite3D(X,Smoke(X)\Rotate+Random(5),1)
      Start3D()
        DisplaySprite3D(X,Smoke(X)\X,Smoke(X)\Y,Smoke(X)\Trans)
      Stop3D()
    EndIf
  Next X
EndProcedure

Procedure UpdateMissles()
  
  ResetList(Missle())
  While NextElement(Missle())
    Missle()\Xpos + Missle()\Xspeed
    If Missle()\Smoke = 1
      AddSmoke(Missle()\Xpos,Missle()\Ypos,-(Random(2)+1),0)
    EndIf
    If Missle()\Xpos > 650 Or Missle()\Xpos < -50
      DeleteElement(Missle()) 
    EndIf
    DisplayTransparentSprite(Missle()\Sprite,Missle()\Xpos,Missle()\Ypos)
  Wend
EndProcedure

; ExecutableFormat=Windows
; EOF